#ifndef COMMANDER_H
#define COMMANDER_H

#include "aliases.h"
#include "commander_output.h"
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef __cplusplus
BEGIN_C_LINKAGE
#endif // __cplusplus

#define CMD_NO_EXIT(ERR) ((CMDResult){.exited = false, .exit_code = EXIT_FAILURE, .error = ERR})
#define wapp_shell_commander_execute(HANDLE_OUTPUT, OUT_BUF, BUF_SIZE, ...)    \
  run_command(HANDLE_OUTPUT, OUT_BUF, BUF_SIZE, __VA_ARGS__, "2>&1", NULL)

CMDResult run_command(CMDOutHandling out_handling, char *out_buf, u64 buf_size, ...);

external CMDError get_output_status(FILE *fp, i32 *status_out);

#ifdef __cplusplus
END_C_LINKAGE
#endif // __cplusplus

#endif // !COMMANDER_H
